﻿window.onload = function(){
	//enchant.js
	enchant();

	//定数
	var VERSION = "1.1_140412";
	var COREW = 320;
	var COREH = 400;
	var WALKSPEED = 6;
	var PENMAXNUM = 3;
	var PENSPEED = 12;
	var SUBJECTNUM = 5;
	var SUBJECTSPEED = 3;
	var RAINSPEED = 16;
	var RAINSPEEDRND = 8;

	//スパゲティ
	var called = false;
	var core = new Core(COREW, COREH);
	core.fps = 15;
	core.keybind(32, "space");
	core.keybind(82, "r");
	core.preload(
		"title.png", "back.png", "jk.png", "subject.png", "pencil.png",
		"delete.wav", "gameover.wav", "bgm.mp3", "soundbtn.png");
	core.onload = function(){
		if(called){ return; }else{ called = true; }		//Firefoxのバグ回避
		//Firefoxだと謎のタイミングでcore.onloadが何度も呼ばれることがある
		//音声再生（停止）時等

		//BGM
		var soundon = true;
		var bgm = core.assets["bgm.mp3"];
		core.addEventListener("enterframe", function(){
			if(soundon){
				bgm.play();
			}
		});

		//タイトル
		var titleScene = new Scene();
		titleScene.addEventListener("touchend", function(e){
			if(e.localY > COREH - 48){ return; }
			core.popScene();
			core.pushScene(newGame());
		});
		var titleSprite = new Sprite(COREW, COREH);
		titleSprite.image = core.assets["title.png"];
		var soundbtn = new Sprite(32, 32);
		soundbtn.image = core.assets["soundbtn.png"];
		soundbtn.x = COREW - 32 - 8;
		soundbtn.y = COREH - 32 - 8;
		soundbtn.addEventListener("touchend", function(){
			if(soundon){
				core.assets["bgm.mp3"].stop();
				soundon = false;
				soundbtn.frame = 1;
			}else{
				soundon = true;
				soundbtn.frame = 0;
			}
		});
		var titleAbout = new Label("About");
		titleAbout.font = "bold 16px メイリオ";
		titleAbout.color = "#ffffff";
		titleAbout.x = 8;
		titleAbout.y = COREH - 20 - 8;
		titleAbout.addEventListener("touchend", function(){
			core.pushScene(aboutScene);
		});
		titleScene.addChild(titleSprite);
		titleScene.addChild(soundbtn);
		titleScene.addChild(titleAbout);
		core.pushScene(titleScene);

		//About
		var aboutScene = new Scene();
		aboutScene.backgroundColor = "rgba(0, 0, 0, 0.5)"
		aboutScene.addEventListener("touchend", function(e){
			if(aboutLabel5.x < e.localX && e.localX < aboutLabel5.x + aboutLabel5._boundWidth
			&& aboutLabel5.y < e.localY && e.localY < aboutLabel5.y + aboutLabel5._boundHeight * 1.5){
				window.open("http://www.rengoku-teien.com/", "_blank")
			}else if(aboutLabel6.x < e.localX && e.localX < aboutLabel6.x + aboutLabel6._boundWidth
			&& aboutLabel6.y < e.localY && e.localY < aboutLabel6.y + aboutLabel6._boundHeight * 1.5){
				window.open("http://osabisi.sakura.ne.jp/m2/", "_blank")
			}else if(aboutLabel7.x < e.localX && e.localX < aboutLabel7.x + aboutLabel7._boundWidth
			&& aboutLabel7.y < e.localY && e.localY < aboutLabel7.y + aboutLabel7._boundHeight * 1.5){
				window.open("http://hauri.ifdef.jp/", "_blank")
			}else{
				core.popScene();
			}
		});
		var aboutVersion = new Label("varsion : " + VERSION);
		aboutVersion.font = "9px メイリオ";
		aboutVersion.color = "#ffffff";
		aboutVersion.textAlign = "right";
		aboutVersion.y = 8;
		var aboutLabel8 = new Label("操作方法");
		aboutLabel8.font = "bold 16px メイリオ";
		aboutLabel8.color = "#ffffff";
		aboutLabel8.textAlign = "center";
		aboutLabel8.y = 32;
		var aboutLabel9 = new Label("左右キー：女子高生移動");
		aboutLabel9.font = "12px メイリオ";
		aboutLabel9.color = "#ffffff";
		aboutLabel9.x = 40;
		aboutLabel9.y = aboutLabel8.y + 24;
		var aboutLabel10 = new Label("スペースキー：鉛筆ミサイル発射");
		aboutLabel10.font = "12px メイリオ";
		aboutLabel10.color = "#ffffff";
		aboutLabel10.x = 40;
		aboutLabel10.y = aboutLabel9.y + 16;
		var aboutLabel1 = new Label("クレジット");
		aboutLabel1.font = "bold 16px メイリオ";
		aboutLabel1.color = "#ffffff";
		aboutLabel1.textAlign = "center";
		aboutLabel1.y = aboutLabel10.y + 44;
		var aboutLabel2 = new Label("・音楽");
		aboutLabel2.font = "16px メイリオ";
		aboutLabel2.color = "#ffffff";
		aboutLabel2.x = 16;
		aboutLabel2.y = aboutLabel1.y + 24;
		var aboutLabel3 = new Label("・効果音");
		aboutLabel3.font = "16px メイリオ";
		aboutLabel3.color = "#ffffff";
		aboutLabel3.x = 16;
		aboutLabel3.y = aboutLabel2.y + 80;
		var aboutLabel4 = new Label("・制作");
		aboutLabel4.font = "16px メイリオ";
		aboutLabel4.color = "#ffffff";
		aboutLabel4.x = 16;
		aboutLabel4.y = aboutLabel3.y + 80;
		var aboutLabel5 = new Label("煉獄庭園<br>    http://www.rengoku-teien.com/");
		aboutLabel5.font = "12px メイリオ";
		aboutLabel5.color = "#ffffff";
		aboutLabel5.x = 40;
		aboutLabel5.y = aboutLabel2.y + 24;
		var aboutLabel6 = new Label("ザ・マッチメイカァズ<br>    http://osabisi.sakura.ne.jp/m2/");
		aboutLabel6.font = "12px メイリオ";
		aboutLabel6.color = "#ffffff";
		aboutLabel6.x = 40;
		aboutLabel6.y = aboutLabel3.y + 24;
		var aboutLabel7 = new Label("のなか<br>    http://hauri.ifdef.jp/");
		aboutLabel7.font = "12px メイリオ";
		aboutLabel7.color = "#ffffff";
		aboutLabel7.x = 40;
		aboutLabel7.y = aboutLabel4.y + 24;
		aboutScene.addChild(aboutVersion);
		aboutScene.addChild(aboutLabel8);
		aboutScene.addChild(aboutLabel9);
		aboutScene.addChild(aboutLabel10);
		aboutScene.addChild(aboutLabel1);
		aboutScene.addChild(aboutLabel2);
		aboutScene.addChild(aboutLabel3);
		aboutScene.addChild(aboutLabel4);
		aboutScene.addChild(aboutLabel5);
		aboutScene.addChild(aboutLabel6);
		aboutScene.addChild(aboutLabel7);

		//リザルト
		var resultScene = new Scene();
		resultScene.backgroundColor = "rgba(0, 0, 0, 0.5)"
		resultScene.addEventListener("enterframe", function(){
			if(core.input.r){
				core.popScene();
				core.popScene();
				core.pushScene(newGame());
			}
		});
		var resultScoreLabel = new Label();
		resultScoreLabel.font = "bold 32px メイリオ";
		resultScoreLabel.color = "#ffffff";
		resultScoreLabel.textAlign = "center";
		resultScoreLabel.y = 60;
		var resultTextLabel2 = new Label(" リスタート（Rキー）");
		resultTextLabel2.font = "bold 16px メイリオ";
		resultTextLabel2.color = "#ffffff";
		resultTextLabel2.textAlign = "center";
		resultTextLabel2.y = 160;
		resultTextLabel2.addEventListener("touchend", function(){
			core.popScene();
			core.popScene();
				core.pushScene(newGame());
		});
		var resultTextLabel = new Label("タイトルに戻る");
		resultTextLabel.font = "bold 16px メイリオ";
		resultTextLabel.color = "#ffffff";
		resultTextLabel.textAlign = "center";
		resultTextLabel.y = 240;
		resultTextLabel.addEventListener("touchend", function(){
			core.popScene();
			core.popScene();
			core.pushScene(titleScene);
		});
		var resultTweetLabel = new Label("ツイートする");
		resultTweetLabel.font = "bold 16px メイリオ";
		resultTweetLabel.color = "#ffffff";
		resultTweetLabel.textAlign = "center";
		resultTweetLabel.y = 320;
		resultTweetLabel.addEventListener("touchend", function(){
			window.open("https://twitter.com/intent/tweet?text="
				+ score + "点 「"
				+ backTexts[~~(backTexts.length*Math.random())]
				+ "」http://hauri.ifdef.jp/develop/bluejk/index.html %23憂鬱な女子高生"
				, "_blank", "");
		});
		resultScene.addChild(resultScoreLabel);
		resultScene.addChild(resultTextLabel2);
		resultScene.addChild(resultTextLabel);
		resultScene.addChild(resultTweetLabel);

		//ゲーム用
		var gameScene;
		var jk;
		var jkwalk = [2,3,4,3];
		var jkstand = 2;
		var jkmotion;
		var buttonStat;
		var pspace;
		var pencnt;
		var score;
		var backSprite = new Sprite(COREW, COREH);
		backSprite.image = core.assets["back.png"];
		var scoreLabel = new Label();
		scoreLabel.font = "bold 20px メイリオ";
		scoreLabel.color = "#ffffff";
		scoreLabel.textAlign = "right";
		scoreLabel.y = 4;
		var backTexts = [
			"終わらない…", "疲れた…", "はあ…", "あはは…", "私…",
			"もうやだ…", "…………", "これが終わったら…", "何もしたくない…", "え…",
			"怖い…", "どうして…？", "嫌われたくない…", "私は何がしたいの…？", "嫌いにならないで…",
			"頑張るからっ…", "もうどうにでもなーれ…", "痛い…", "楽しくない…", "はい…", 
			"うん…", "えっと…", "あの…", "大丈夫…", "ごめん…",
			"何のために…", "生きる…", "あ…", "ごめんなさい…", "怖い…",
			"どうしたら…", "雨…", "楽しい？", "愛…", "寒い…",
			"あーあ…", "どうしよう…", "もうやだ…", "…っ！","生きるのが辛い…",
			"しにたい…"
		];

		/* 関数 */
		//ゲーム
		function newGame(){
			gameScene = new Scene();
			gameScene.backgroundColor = "#f0f0f0";
			gameScene.addEventListener("enterframe", function(){
				if(core.input.left){
					jk.scaleX = 1;
					jk.x -= WALKSPEED;
				}
				if(core.input.right){
					jk.scaleX = -1;
					jk.x += WALKSPEED;
				}
				if(core.input.left ^ core.input.right){
					if(jkmotion == "stand"){
						jk.frame = jkwalk;
						jkmotion = "walk";
					}
				}else{
					jk.frame = jkstand;
					jkmotion = "stand";
				}
				if((pspace == false) && core.input.space){
					addPen();
				}
				pspace = core.input.space;
				if(jk.x + 24 < 0){
					jk.x = 0 - 24;
				}
				if(jk.x + 64 - 24 > COREW){
					jk.x = COREW - 64 + 24;
				}

				//宿題
				if((gameScene.age % 45 == 15) || (Math.random() < gameScene.age/(15*60)*0.05)){
					addSubject();
				}

				//バックテキスト
				if((gameScene.age % 75 == 0) || Math.random() < (1/150)){
					var backText = new Label(backTexts[~~(backTexts.length*Math.random())]);
					backText.font = ""+ ~~(6+10*Math.random()) +"px メイリオ";
					backText.color = "#ffffff";
					backText.x = (COREW - backText._boundWidth) * Math.random();
					backText.y = (COREH - 16) * Math.random();
					backText.addEventListener("enterframe", function(){
						this.color = "rgba(255,255,255,"+ (1 - this.age / 75) +")";
						if(this.age > 75){
							gameScene.removeChild(this);
						}
					});
					gameScene.insertBefore(backText, gameScene.childNodes[1]);
				}

				//雨
				for(var i=0; i<1+3*Math.random(); i++){
					addRain();
				}

				scoreLabel.text = score;
			});

			//いろいろ
			buttonStat = 0;
			pspace = false;
			pencnt = 0;
			score = 0;

			//JK
			jk = new Sprite(64, 80);
			jk.type = "jk";
			jk.image = core.assets["jk.png"];
			jkwalk = [2,3,4,3];
			jkstand = 2;
			jkmotion = "stand";
			jk.frame = jkstand;
			jk.x = COREW/2 - 32;
			jk.y = COREH - 80;

			//追加
			gameScene.addChild(backSprite);
			gameScene.addChild(jk);
			gameScene.addChild(scoreLabel);

			return gameScene;
		}
		//鉛筆ミサイル
		function addPen(){
			if(pencnt >= PENMAXNUM){ return; }
			var pen = new Sprite(8, 24);
			pen.type = "pen";
			pen.image = core.assets["pencil.png"];
			pen.x = jk.x + 32 - 4;
			pen.y = jk.y;
			pen.addEventListener("enterframe", function(){
				this.y -= PENSPEED;
				for(var i=0; i<gameScene.childNodes.length; i++){
					if(!"type" in gameScene.childNodes[i]){ break; }
					if(gameScene.childNodes[i].type == "subject"){
						if(this.intersect(gameScene.childNodes[i])){
							if(soundon){
								core.assets["delete.wav"].clone().play();
							}
							score += 1;
							pencnt--;
							gameScene.removeChild(gameScene.childNodes[i]);
							gameScene.removeChild(this);
						}
					}
				}
				if(pen.y+24 < 0){
					pencnt--;
					gameScene.removeChild(this);
				}
			});
			pencnt++;
			gameScene.insertBefore(pen, scoreLabel);
		}
		//宿題追加
		function addSubject(){
			//return;
			var subject = new Sprite(24, 32);
			subject.type = "subject";
			subject.image = core.assets["subject.png"];
			subject.frame = SUBJECTNUM * Math.random() / 2 + SUBJECTNUM * Math.random() / 2;		//宿題量の偏り
			subject.x = (COREW-24) * Math.random();
			subject.y = -32;
			subject.addEventListener("enterframe", function(){
				this.y += SUBJECTSPEED;
				if(this.y+32 > COREH){
					if(soundon){
						core.assets["gameover.wav"].clone().play();
					}
					resultScoreLabel.text = "スコア：" + score;
					core.pushScene(resultScene);
				}
			});
			gameScene.insertBefore(subject, scoreLabel);
		}
		//雨
		function addRain(){
			var rain = new Sprite(1, 4);
			rain.backgroundColor = "#999999"
			rain.x = (COREW-1) * Math.random();
			rain.y = -4;
			rain.addEventListener("enterframe", function(){
				this.y += RAINSPEED + RAINSPEEDRND * Math.random();
				if(this.y > COREH - RAINSPEED - RAINSPEEDRND - 4){
					var raindrop = new Sprite(4, 1);
					raindrop.backgroundColor = "#CCCCCC"
					raindrop.x = this.x - 2;
					raindrop.y = this.y + 2;
					raindrop.addEventListener("enterframe", function(){
						raindrop.backgroundColor = "rgba(204,204,204,"+ (1 - this.age / 30) +")";
						if(this.age > 30){
							gameScene.removeChild(this);
						}
					});
					gameScene.insertBefore(raindrop, this);
					gameScene.removeChild(this);
				}
			});
			gameScene.insertBefore(rain, jk);
		}
	}
	core.start();
};

